Agora RTC Objective-C API Reference Refactor

Data Fields
RemoteAudioStats Struct Reference

## Data Fields
uid_t | uid
int | quality
int | networkTransportDelay
int | jitterBufferDelay
int | audioLossRate
int | numChannels
int | receivedSampleRate
int | receivedBitrate
int | totalFrozenTime
int | frozenRate
int | mosValue
uint32_t | frozenRateByCustomPlcCount
uint32_t | plcCount
int | totalActiveTime
int | publishDuration
int | qoeQuality
int | qualityChangedReason
unsigned int | rxAudioBytes
int | e2eDelay

## Detailed Description

Audio statistics of the remote user.

## Constructor & Destructor Documentation

## ◆ RemoteAudioStats()

RemoteAudioStats | ( |  | ) |
| inline

## Field Documentation

## ◆ uid

uid_t uid

User ID of the remote user sending the audio stream.

## ◆ quality

int quality

The quality of the remote audio: QUALITY_TYPE.

## ◆ networkTransportDelay

int networkTransportDelay

The network delay (ms) from the sender to the receiver.

## ◆ jitterBufferDelay

int jitterBufferDelay

The network delay (ms) from the receiver to the jitter buffer.

Note
  When the receiving end is an audience member and `audienceLatencyLevel` of `ClientRoleOptions` is 1, this parameter does not take effect.

## ◆ audioLossRate

int audioLossRate

The audio frame loss rate in the reported interval.

## ◆ numChannels

int numChannels

The number of channels.

## ◆ receivedSampleRate

int receivedSampleRate

The sample rate (Hz) of the remote audio stream in the reported interval.

## ◆ receivedBitrate

int receivedBitrate

The average bitrate (Kbps) of the remote audio stream in the reported interval.

## ◆ totalFrozenTime

int totalFrozenTime

The total freeze time (ms) of the remote audio stream after the remote user joins the channel.

In a session, audio freeze occurs when the audio frame loss rate reaches 4%.

## ◆ frozenRate

int frozenRate

The total audio freeze time as a percentage (%) of the total time when the audio is available.

## ◆ mosValue

int mosValue

The quality of the remote audio stream as determined by the Agora real-time audio MOS (Mean Opinion Score) measurement method in the reported interval. The return value ranges from 0 to 500. Dividing the return value by 100 gets the MOS score, which ranges from 0 to 5. The higher the score, the better the audio quality.

MOS score | Perception of audio quality
--- | ---
Greater than 4 | Excellent. The audio sounds clear and smooth.
From 3.5 to 4 | Good. The audio has some perceptible impairment, but still sounds clear.
From 3 to 3.5 | Fair. The audio freezes occasionally and requires attentive listening.
From 2.5 to 3 | Poor. The audio sounds choppy and requires considerable effort to understand.
From 2 to 2.5 | Bad. The audio has occasional noise. Consecutive audio dropouts occur, resulting in some information loss. The users can communicate only with difficulty.
Less than 2 | Very bad. The audio has persistent noise. Consecutive audio dropouts are frequent, resulting in severe information loss. Communication is nearly impossible.

## ◆ frozenRateByCustomPlcCount

uint32_t frozenRateByCustomPlcCount

If the packet loss concealment (PLC) occurs for N consecutive times, freeze is considered as PLC occurring for M consecutive times. freeze cnt = (n_plc - n) / m

## ◆ plcCount

uint32_t plcCount

The number of audio packet loss concealment

## ◆ totalActiveTime

int totalActiveTime

The total time (ms) when the remote user neither stops sending the audio stream nor disables the audio module after joining the channel.

## ◆ publishDuration

int publishDuration

The total publish duration (ms) of the remote audio stream.

## ◆ qoeQuality

int qoeQuality

Quality of experience (QoE) of the local user when receiving a remote audio stream. See EXPERIENCE_QUALITY_TYPE.

## ◆ qualityChangedReason

int qualityChangedReason

The reason for poor QoE of the local user when receiving a remote audio stream. See EXPERIENCE_POOR_REASON.

## ◆ rxAudioBytes

unsigned int rxAudioBytes

The total number of audio bytes received (bytes), inluding the FEC bytes, represented by an aggregate value.

## ◆ e2eDelay

int e2eDelay

The end-to-end delay (ms) from the sender to the receiver.